program anneau
  use mpi
  implicit none
  integer, dimension(MPI_STATUS_SIZE) :: statut
  integer, parameter                  :: etiquette=300
  integer                             :: nb_processus, rang,num_proc_precedent, num_proc_suivant, code
  integer                             :: i
  real, dimension (1:2)               :: T, V
  call MPI_INIT (code)
  call MPI_COMM_SIZE (MPI_COMM_WORLD, nb_processus, code)
  call MPI_COMM_RANK (MPI_COMM_WORLD, rang, code)
  num_proc_precedent = mod(nb_processus+rang-1, nb_processus)
  num_proc_suivant   = mod(rang+1, nb_processus)
  do i = 1, 2
   T(i)=0.1*rang*i
  end do
  if (rang == 0) then
     call MPI_SEND (T, 2, MPI_REAL, num_proc_suivant, etiquette, MPI_COMM_WORLD, code)
     call MPI_RECV (V, 2, MPI_REAL, num_proc_precedent, etiquette, MPI_COMM_WORLD, statut, code)
  else
     call MPI_RECV (V, 2, MPI_REAL, num_proc_precedent, etiquette, MPI_COMM_WORLD, statut, code)
     call MPI_SEND (T, 2, MPI_REAL, num_proc_suivant, etiquette, MPI_COMM_WORLD, code)
  end if
  print *,'Moi=',rang,', j''ai recu le tableau de valeurs ',V(1),' et ',V(2),' du coeur=',num_proc_precedent
  call MPI_FINALIZE(code)
end program anneau
