!============
module mod_gc
!============
!
contains
!
!=====================
function gc (A, b, u0)
!=====================
!
        use mod_data
        use mod_matvec
        use mod_pdscal
        use mod_normvect
!
        implicit none
!
	real(kind=8), dimension(:,:), intent(in) :: A
	real(kind=8), dimension(:),   intent(in) :: b
	real(kind=8), dimension(:),   intent(in) :: u0
        real(kind=8), dimension(size(b))         :: gc
        real(kind=8), dimension(size(b))         :: p, q, r
        real(kind=8)                             :: rr, rr1, pq, alpha, beta
        integer                                  :: k, n
!
        n = size(b)
!
!       Initialisation
        gc            = u0
        r             = 0.d0
        q             = 0.d0
        p             = 0.d0
        r             = b - A*gc
        p             = r
        niterx        = 0
        normresx      = normL2 (r)
!       print*,'norme residu initialisation du gc =', normresx
!
!
!
!       Iterations
        do k = 1, niterxmax
         niterx       = k
         rr           = r.scal.r
         q            = A*p
         pq           = p.scal.q
         alpha        = rr / pq
         gc           = gc + alpha*p
         r            = r  - alpha*q
         normresx     = normL2 (r)
!        print*,'norme residu iteration ',k,' du gc =',normresx
         if (normresx<=epsx) exit
         rr1          = r.scal.r
         beta         = rr1 / rr
         p            = r + beta*p
        end do
!
!==============
end function gc
!==============
!
!================
end module mod_gc
!================
