!==================
module mod_normvect
!==================
!
contains
!
!==================
function normL1 (v)
!==================
!
        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension (:), intent(in) :: v
        real(kind=8) :: normL1
        real(kind=8) :: normL1loc
        integer :: i, n
!
        n = size(v)
!
        normL1 = 0.d0
        do i = 1, n
         normL1 = normL1 + abs(v(i))
        end do
        normL1loc = normL1
!
        call MPI_ALLREDUCE (normL1loc, normL1, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, code)
!
!==================
end function normL1
!==================
!
!==================
function normL2 (v)
!==================
!
        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension (:), intent(in) :: v
        real(kind=8) :: normL2
        real(kind=8) :: normL2loc
        integer :: i, n
!
        n = size(v)
!
        normL2 = 0.d0
        do i = 1, n
         normL2 = normL2 + abs(v(i))**2
        end do
        normL2loc = normL2
!
        call MPI_ALLREDUCE (normL2loc, normL2, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, code)
!
        normL2 = dsqrt(normL2)
!
!==================
end function normL2
!==================
!
!====================
function normLinf (v)
!====================
!
        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension(:), intent(in) :: v
        real(kind=8) :: normLinf
        real(kind=8) :: normLinfloc
!
        normLinf = maxval(abs(v))
        normLinfloc = normLinf
!
        call MPI_ALLREDUCE (normLinfloc, normLinf, 1, MPI_DOUBLE_PRECISION, MPI_MAX, MPI_COMM_WORLD, code)
!
!====================
end function normLinf
!====================
!
!======================
end module mod_normvect
!======================
