!================
module mod_pdscal
!================
!
!==========================
interface operator (.scal.)
!==========================
!
        module procedure pdscal
!
!============
end interface
!============
!
contains
!
!=====================
function pdscal (x, y)
!=====================
!
        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension (:), intent (in) :: x, y
        real(kind=8) :: pdscal
        real(kind=8) :: pdscalloc
        integer :: n, i
!
        n = size(x)
!
        pdscal = 0.d0
        do i = 1, n
         pdscal = pdscal + x(i)*y(i)
        end do
        pdscalloc = pdscal
!
        call MPI_ALLREDUCE (pdscalloc, pdscal, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, code)
!
!==================
end function pdscal
!==================
!
!====================
end module mod_pdscal
!====================
